name: Activities & lifecycles
goals:
    android-navigation: 1
resources:
    -
        link: https://classroom.udacity.com/courses/ud839/lessons/a6aa079b-ea92-47fa-a537-562f6f47ea34/concepts/5d4ab89d-7ae2-425a-ac96-dc34a876a1d9
        title: Udacity - Intents & Activities
        info: This interactive lesson (free account required) explains things really well, but slooowly. If you choose to work through this, we recommend you skip parts, read diagonally and double the playback speed. 
    -
        link: https://www.youtube.com/watch?v=6ow3L39Wxmg
        title: "Android Studio For Beginners Part 2"
        info: This is a shorter and more practical explanation.
    -
        link: https://www.youtube.com/watch?v=Be5EYyd_OH8
        title: "Android Beginner Tutorial #15 - Android Activity Lifecycle"
        info: The Activity lifecycle explained.
    -
        link: https://developer.android.com/guide/components/activities/activity-lifecycle
        title: Android documentation - Understand the Activity Lifecycle
        info: This page from the official Android documentation is a bit long, but explains what's going on pretty well and in a lot more detail. We recommend that you at least scan through this.
assignment:
    - |
        Extend your dice app from *My First App* to match the following additional objectives:

    -
        ^merge: feature
        code: 0.25
        text: When clicking one of the two dice images on in the `MainActivity`, a new `Activity` showing a large image of that dice must be shown. You should only need to create one additional activity for this, capable of showing any side of the dice.
    -
        ^merge: feature
        code: 0.25
        text: |
            Although clicking a dice now opens a new Activity, we still want to cheat! So now clicking on the large dice should increment its value. Use `startActivityForResult` to communicate the new dice value back to the `MainActivity`.

            Note that `startActivityForResult` is now *deprecated* in favour of `registerForActivityResult`. You may use the new API if you prefer, but rest assured that the old one isn't about to disappear anytime soon.

            *Hint:* From within the second `Activity`, the `setResult` method can be called more than once. This will override any previous result, causing the latest result to be delivered back to the `MainActivity` once the second `Activity` closes.

    -
        link: https://www.youtube.com/watch?v=TcTgbVudLyQ
        title: Android Studio Tutorial - How to Restore Variables When Rotating the Device
    -
        ^merge: feature
        code: 0.25
        text: Have the dice values survive configuration (orientation) changes using `savedInstanceState` and `onSaveInstanceState`. This also makes sure that when coming back to the app after some time, the dice have not suddenly changed. This applies to both Activities.

    -
        link: https://www.youtube.com/watch?v=JkVdP-e9BCo
        title: Android Studio Tutorial - How to Add an Up Button to the AppBar
        info: The `setDisplayHomeAsUpEnabled` call is actually not really needed. This video also shows how to set the title for an Activity. 
    -
        link: https://getaround.tech/android-parent-navigation/
        title: Implementing Up Navigation on Android
        info: Specifically the part about `launchMode` may be helpful.
    -
        ^merge: feature
        code: 0.25
        text: On the large dice image Activity, change the title in the ActionBar to *First dice* or *Second dice* (depending on which dice was tapped). Also, the ActionBar should have an arrow on the left that navigates *up* to our `MainActivity`. Navigating *up* should of course preserve the dice values in the MainActivity. If `onActivityResult` is not called when navigating *up*, study the `launchMode` mentioned in the above article again.
        
    -
        link: https://www.youtube.com/watch?v=C_Ka7cKwXW0
        title: Android Studio Tutorial - How to Play a Sound File Using the MediaPlayer Class
    -   
        ^merge: feature
        code: 0.25
        text: And, last but least, play an appropriate sound when rolling the dice! :-)
